# Variant Attributes Retrieve a lightweight attribute response for variants. The Variant Attributes endpoint is a read-only sub-resource of [Product Projections](/api/projects/productProjections.md) designed for building attribute selectors on product detail pages (PDPs). It returns only requested Variant-level [Attributes](/api/projects/products.md#attribute) and minimal availability data for all [Variants](/api/projects/variants.md#variant) of a [Product](/api/projects/products.md). This makes it suitable for Products with large numbers of Variants. This endpoint is only available for Projects with [productCatalogModel](/api/projects/project.md#productcatalogmodel) set to `Modular`. To use this endpoint, specify which Variant-level Attributes to include in the response using the required `filter[attributes]` query parameter. Product-level Attributes are ignored. The response contains: - **Attribute metadata** from the [ProductType](/api/projects/productTypes.md), including the Attribute name, localized label, and type. - **Variant entries** with only the requested Attributes and lightweight availability data. ### Availability By default, only the no-channel availability (from [Inventory Entries](/api/projects/inventory.md) without a supply [Channel](/api/projects/channels.md)) is included. To include per-channel availability, specify the supply Channel IDs using the `filter[supplyChannels]` query parameter. ### Locale projection To reduce the response size, use the `localeProjection` query parameter to filter [LocalizedString](/api/types.md#localizedstring) values to specific locales. This affects both the Attribute metadata labels and the variant Attribute values (for example, `lenum` labels and `ltext` values). We recommend using `localeProjection` to minimize the response size. ## Representations ### VariantAttributes [type definition](/api/projects/variant-attributes.md?urn=ctp:api:type:VariantAttributes). ### VariantAttributesAttributeMetadata [type definition](/api/projects/variant-attributes.md?urn=ctp:api:type:VariantAttributesAttributeMetadata). ### VariantAttributesVariant [type definition](/api/projects/variant-attributes.md?urn=ctp:api:type:VariantAttributesVariant). ### VariantAttributesAvailability [type definition](/api/projects/variant-attributes.md?urn=ctp:api:type:VariantAttributesAvailability). ### VariantAttributesChannelAvailability [type definition](/api/projects/variant-attributes.md?urn=ctp:api:type:VariantAttributesChannelAvailability). ## Get Variant Attributes ### Get Variant Attributes by Product ID [endpoint definition](/api/projects/variant-attributes.md?urn=ctp:api:endpoint:/\{projectKey}/product-projections/\{id}/variant-attributes:GET). ### Get Variant Attributes by Product Key [endpoint definition](/api/projects/variant-attributes.md?urn=ctp:api:endpoint:/\{projectKey}/product-projections/key=\{key}/variant-attributes:GET). ## Get Variant Attributes in Store ### Get Variant Attributes in Store by Product ID [endpoint definition](/api/projects/variant-attributes.md?urn=ctp:api:endpoint:/\{projectKey}/in-store/key=\{storeKey}/product-projections/\{id}/variant-attributes:GET). ### Get Variant Attributes in Store by Product Key [endpoint definition](/api/projects/variant-attributes.md?urn=ctp:api:endpoint:/\{projectKey}/in-store/key=\{storeKey}/product-projections/key=\{key}/variant-attributes:GET). ## Related pages - [Area overview page with navigation](/api.md) - [Previous page: Variants](/api/projects/variants.md) - [Next page: Variant Projections](/api/projects/variant-projections.md)